%global bootstrap 1
Summary:    Apache Maven is a software project management and comprehension tool
Name:       maven
Version:    3.9.9
Release:    2%{?dist}
License:    Apache-2.0
URL:        https://maven.apache.org/
# wget --content-disposition github/tags/tar.gz/url
Source0:    https://github.com/apache/maven/archive/maven-3.9.9/maven-maven-3.9.9.tar.gz
Source1:    https://github.com/apache/maven-resolver/archive/maven-resolver-1.9.22/maven-resolver-maven-resolver-1.9.22.tar.gz
Source2:    https://github.com/apache/maven-shared-utils/archive/maven-shared-utils-3.4.2/maven-shared-utils-maven-shared-utils-3.4.2.tar.gz
Source3:    https://github.com/google/guice/archive/5.1.0/guice-5.1.0.tar.gz
# cvs -d:pserver:anonymous@aopalliance.cvs.sourceforge.net:/cvsroot/aopalliance login
# password empty
# cvs -z3 -d:pserver:anonymous@aopalliance.cvs.sourceforge.net:/cvsroot/aopalliance export -r HEAD aopalliance
# tar acf aopalliance-1.0.tar.gz aopalliance
Source4:    aopalliance-1.0.tar.gz
Source5:    https://github.com/google/guava/archive/v33.2.1/guava-33.2.1.tar.gz
Source6:    https://github.com/javax-inject/javax-inject/archive/1/javax-inject-1.tar.gz
Source7:    https://github.com/javaee/javax.annotation/archive/1.3.2/javax.annotation-1.3.2.tar.gz
Source8:    https://github.com/codehaus-plexus/plexus-utils/archive/plexus-utils-3.5.1/plexus-utils-plexus-utils-3.5.1.tar.gz
Source9:    https://github.com/codehaus-plexus/plexus-classworlds/archive/plexus-classworlds-2.8.0/plexus-classworlds-plexus-classworlds-2.8.0.tar.gz
Source10:   https://github.com/codehaus-plexus/plexus-sec-dispatcher/archive/plexus-sec-dispatcher-2.0/plexus-sec-dispatcher-plexus-sec-dispatcher-2.0.tar.gz
Source11:   https://github.com/codehaus-plexus/plexus-cipher/archive/plexus-cipher-2.0/plexus-cipher-plexus-cipher-2.0.tar.gz
Source12:   https://github.com/codehaus-plexus/plexus-interpolation/archive/plexus-interpolation-1.27/plexus-interpolation-plexus-interpolation-1.27.tar.gz
Source13:   https://github.com/qos-ch/slf4j/archive/v_1.7.36/slf4j-v_1.7.36.tar.gz
Source14:   https://github.com/eclipse-sisu/sisu-project/archive/milestones/0.9.0.M3/sisu-project-milestones-0.9.0.M3.tar.gz
Source15:   https://github.com/codehaus-plexus/plexus-containers/archive/plexus-containers-2.1.0/plexus-containers-plexus-containers-2.1.0.tar.gz
Source16:   https://github.com/apache/maven-wagon/archive/wagon-3.5.3/maven-wagon-wagon-3.5.3.tar.gz
Source17:   https://github.com/codehaus-plexus/plexus-xml/archive/plexus-xml-3.0.1/plexus-xml-plexus-xml-3.0.1.tar.gz
Source18:   https://github.com/apache/commons-cli/archive/rel/commons-cli-1.8.0/commons-cli-rel-commons-cli-1.8.0.tar.gz
Source19:   https://github.com/apache/httpcomponents-client/archive/rel/v4.5.14/httpcomponents-client-rel-v4.5.14.tar.gz
Source20:   https://github.com/apache/httpcomponents-core/archive/rel/v4.4.16/httpcomponents-core-rel-v4.4.16.tar.gz
Source21:   https://github.com/apache/commons-codec/archive/rel/commons-codec-1.17.1/commons-codec-rel-commons-codec-1.17.1.tar.gz
Source22:   https://github.com/fusesource/jansi/archive/jansi-2.4.1/jansi-jansi-2.4.1.tar.gz
Source23:   https://github.com/apache/ant/archive/rel/1.10.15/ant-rel-1.10.15.tar.gz
Source24:   pom-modify.py
%if %bootstrap
Source25:   https://dlcdn.apache.org/maven/maven-3/3.9.9/binaries/apache-maven-3.9.9-bin.tar.gz
%else
BuildRequires: maven >= 3.9.9
%endif
BuildRequires:  java-1.8.0-devel, java-17-devel, python3-lxml, python3
BuildRequires:  maven-buildrequires = %{version}
# use java 17 for default
Requires:   java-17-konajdk-devel
## runtime
# maven
Provides:   maven-lib = %{version}-%{release}
Obsoletes:  maven < 3.9.9
Obsoletes:  maven-lib < 3.9.9
Obsoletes:  maven-openjdk8 < 3.9.9
Obsoletes:  maven-openjdk11 < 3.9.9
Obsoletes:  maven-openjdk17 < 3.9.9
# maven-resolver
Provides:   maven-resolver = 1.9.22-%{release}
Obsoletes:  maven-resolver < 1.9.22
Obsoletes:  maven-resolver-javadoc  < 1.9.22
# maven-shared-utils
Provides:   maven-shared-utils = 3.4.2-%{release}
Obsoletes:  maven-shared-utils < 3.4.2
Obsoletes:  maven-shared-utils-javadoc < 3.4.2
# google-guice
Provides:   google-guice = 5.1.0-%{release}
Obsoletes:  google-guice < 5.1.0
Obsoletes:  google-guice-javadoc < 5.1.0
Obsoletes:  guice-assistedinject < 5.1.0
Obsoletes:  guice-bom < 5.1.0
Obsoletes:  guice-extensions < 5.1.0
Obsoletes:  guice-grapher < 5.1.0
Obsoletes:  guice-jmx < 5.1.0
Obsoletes:  guice-jndi < 5.1.0
Obsoletes:  guice-multibindings < 5.1.0
Obsoletes:  guice-parent < 5.1.0
Obsoletes:  guice-servlet < 5.1.0
Obsoletes:  guice-throwingproviders < 5.1.0
# aopalliance none
# guava
Provides:   guava = 33.2.1-%{release}
Obsoletes:  guava < 33.2.1
Obsoletes:  guava-javadoc < 33.2.1
Obsoletes:  guava-testlib < 33.2.1
# javax-inject none
# javax.annotation none
# plexus-utils
Provides:   plexus-utils = 3.5.1-%{release}
Obsoletes:  plexus-utils < 3.5.1
Obsoletes:  plexus-utils-javadoc < 3.5.1
# plexus-classworlds
Provides:   plexus-classworlds = 2.8.0-%{release}
Obsoletes:  plexus-classworlds < 2.8.0
Obsoletes:  plexus-classworlds-javadoc < 2.8.0
# plexus-sec-dispatcher
Provides:   plexus-sec-dispatcher = 1:2.0-%{release}
Obsoletes:  plexus-sec-dispatcher < 1:2.0
Obsoletes:  plexus-sec-dispatcher-javadoc < 1:2.0
# plexus-cipher
Provides:   plexus-cipher = 1:2.0-%{release}
Obsoletes:  plexus-cipher < 1:2.0
Obsoletes:  plexus-cipher-javadoc < 1:2.0
# plexus-interpolation
Provides:   plexus-interpolation = 1.27-%{release}
Obsoletes:  plexus-interpolation < 1.27
Obsoletes:  plexus-interpolation-javadoc < 1.27
# slf4j
Provides:   slf4j = 1.7.36-%{release}
Obsoletes:  jcl-over-slf4j < 1.7.36
Obsoletes:  jul-to-slf4j < 1.7.36
Obsoletes:  log4j-over-slf4j < 1.7.36
Obsoletes:  slf4j < 1.7.36
Obsoletes:  slf4j-javadoc < 1.7.36
Obsoletes:  slf4j-jcl < 1.7.36
Obsoletes:  slf4j-jdk14 < 1.7.36
Obsoletes:  slf4j-manual < 1.7.36
Obsoletes:  slf4j-migrator < 1.7.36
Obsoletes:  slf4j-sources < 1.7.36
# sisu
Provides:   sisu = 0.9.0.M3-%{release}
Obsoletes:  sisu < 0.9.0.M3
Obsoletes:  sisu-javadoc < 0.9.0.M3
# plexus-containers
Provides:   sisu = 1:2.1.0-%{release}
Obsoletes:  plexus-containers < 1:2.1.0
Obsoletes:  plexus-containers-component-annotations < 1:2.1.0
Obsoletes:  plexus-containers-component-metadata < 1:2.1.0
Obsoletes:  plexus-containers-container-default < 1:2.1.0
Obsoletes:  plexus-containers-javadoc < 1:2.1.0
# maven-wagon
Provides:   maven-wagon = 3.5.3-%{release}
Obsoletes:  maven-wagon < 3.5.3
Obsoletes:  maven-wagon-javadoc < 3.5.3
# plexus-xml none
# commons-cli
Provides:   apache-commons-cli = 1.8.0-%{release}
Obsoletes:  apache-commons-cli < 1.8.0
Obsoletes:  apache-commons-cli-javadoc < 1.8.0
# httpcomponents-client
Provides:   httpcomponents-client = 4.5.14-%{release}
Obsoletes:  httpcomponents-client < 4.5.14
Obsoletes:  httpcomponents-client-javadoc < 4.5.14
# httpcomponents-core
Provides:   httpcomponents-core = 4.4.16-%{release}
Obsoletes:  httpcomponents-core < 4.4.16
Obsoletes:  httpcomponents-core-javadoc < 4.4.16
# commons-codec
Provides:   apache-commons-codec = 1.17.1-%{release}
Obsoletes:  apache-commons-codec < 1.17.1
Obsoletes:  apache-commons-codec < 1.17.1
# jansi
Provides:   jansi = 2.4.1-%{release}
Obsoletes:  jansi < 2.4.1
Obsoletes:  jansi-javadoc < 2.4.1

Obsoletes:  apache-commons-io <= 2.11.0
Obsoletes:  apache-commons-io-javadoc <= 2.11.0
Obsoletes:  atinject <= 3.12.0
Obsoletes:  atinject-javadoc <= 3.12.0
Obsoletes:  cdi-api <= 2.0.2
Obsoletes:  cdi-api-javadoc <= 2.0.2
Obsoletes:  jakarta-annotations-javadoc <= 1.3.5
Obsoletes:  jakarta-annotations <= 1.3.5
Obsoletes:  jsr-305-javadoc <= 3.0.2
Obsoletes:  jsr-305 <= 3.0.2

## build env


BuildArch:  noarch
AutoReqProv:no



%description
Maven's primary goal is to allow a developer to comprehend the complete state
of a development effort in the shortest period of time. In order to attain this
goal, Maven deals with several areas of concern:
  - Making the build process easy
  - Providing a uniform build system
  - Providing quality project information
  - Encouraging better development practices



%prep
%setup -c -T -a 0
tar axvf %{SOURCE0}
tar axvf %{SOURCE1}
tar axvf %{SOURCE2}
tar axvf %{SOURCE3}
tar axvf %{SOURCE4}
tar axvf %{SOURCE5}
tar axvf %{SOURCE6}
tar axvf %{SOURCE7}
tar axvf %{SOURCE8}
tar axvf %{SOURCE9}
tar axvf %{SOURCE10}
tar axvf %{SOURCE11}
tar axvf %{SOURCE12}
tar axvf %{SOURCE13}
tar axvf %{SOURCE14}
tar axvf %{SOURCE15}
tar axvf %{SOURCE16}
tar axvf %{SOURCE17}
tar axvf %{SOURCE18}
tar axvf %{SOURCE19}
tar axvf %{SOURCE20}
tar axvf %{SOURCE21}
tar axvf %{SOURCE22}
tar axvf %{SOURCE23}

# pom modifier tool
cp %{SOURCE24} .
modify_module="python3 ./pom-modify.py"

# for bootstrap
%if %bootstrap
tar axvf %{SOURCE25}
%endif

# maven-resolver
${modify_module} --removemodule "maven-resolver-named-locks-hazelcast" "maven-resolver-named-locks-redisson" "maven-resolver-test-util" "maven-resolver-transport-classpath" "maven-resolver-supplier" "maven-resolver-demos" -d maven-resolver-maven-resolver-1.9.22
# guice
${modify_module} --removemodule "bom" "extensions" -d guice-5.1.0
# guava
${modify_module} --addmodule "futures/failureaccess" -d guava-33.2.1
${modify_module} --removemodule "guava-bom" "guava-gwt" "guava-testlib" "guava-tests" -d guava-33.2.1
# slf4j
sed -i 's/tasks>/target>/g' slf4j-v_1.7.36/slf4j-api/pom.xml
sed -i "s/tasks>/target>/g" slf4j-v_1.7.36/integration/pom.xml
${modify_module} --removemodule "slf4j-simple" "slf4j-nop" "slf4j-jdk14" "slf4j-log4j12" "slf4j-reload4j" "slf4j-jcl" "slf4j-android" "slf4j-ext" "log4j-over-slf4j" "jul-to-slf4j" "osgi-over-slf4j" "integration" "slf4j-site" "slf4j-migrator" -d slf4j-v_1.7.36
# sisu
${modify_module} --removemodule "org.eclipse.sisu.inject.extender" "org.eclipse.sisu.plexus.extender" "org.eclipse.sisu.mojos" -d sisu-project-milestones-0.9.0.M3
# plexus-containers
${modify_module} --removemodule "plexus-component-metadata" "plexus-container-default" -d plexus-containers-plexus-containers-2.1.0
# maven-wagon
${modify_module} --removemodule "wagon-provider-test" "wagon-tcks" -d maven-wagon-wagon-3.5.3
# maven-wagon sub-project
${modify_module} --removemodule "wagon-ftp"  "wagon-http-lightweight" "wagon-scm" "wagon-ssh-external" "wagon-ssh-common" "wagon-ssh-common-test" "wagon-ssh" "wagon-webdav-jackrabbit" -d maven-wagon-wagon-3.5.3/wagon-providers
#httpcomponents-client
${modify_module} --removemodule "httpmime" "fluent-hc" "httpclient-cache" "httpclient-win" "httpclient-osgi" -d commons-cli-rel-commons-cli-1.8.0
#httpcomponents-core
${modify_module} --removemodule "httpcore-nio" "httpcore-osgi" "httpcore-ab" -d httpcomponents-core-rel-v4.4.16



%build
# maven macro later
export JAVA_HOME="/usr/lib/jvm/java-17"
export PATH="${JAVA_HOME}/bin":"${PATH}"
export MAVEN_OPTS='-Xmx512m'

%if %bootstrap
MVN="%{_builddir}/%{NAME}-%{VERSION}/apache-maven-3.9.9/bin/mvn $@"
%else
MVN="/usr/bin/mvn $@"
%endif

#mvn_build="${MVN} -X clean package -Dgpg.skip=true -Dmaven.test.skip=true -Dmaven.javadoc.skip=true $@"
mvn_build="${MVN} -X -o clean package -Dgpg.skip=true -Dmaven.test.skip=true -Dmaven.javadoc.skip=true -Dmaven.repo.local=/usr/lib/maven/repository/ $@"

# ant, buildtools for aopalliance
pushd ant-rel-1.10.15
JAVA_HOME="/usr/lib/jvm/java-1.8.0" PATH="${JAVA_HOME}/bin":"${PATH}" ./build.sh -Ddist.dir=./dist -Djavadoc.notrequired=true dist
popd
# aopalliance
pushd aopalliance
JAVA_HOME="/usr/lib/jvm/java-1.8.0" PATH="${JAVA_HOME}/bin":"${PATH}" ../ant-rel-1.10.15/dist/bin/ant -Dbuild.sysclasspath=only jar javadoc -Dant.build.javac.source=1.8 -Dant.build.javac.target=1.8
mkdir target
cp -f build/aopalliance.jar target/aopalliance-1.0.jar
popd
# javax-inject
pushd javax-inject-1
JAVA_HOME="/usr/lib/jvm/java-1.8.0" PATH="${JAVA_HOME}/bin":"${PATH}" ./build.sh
mkdir target
cp -f build/maven/*.jar target/
popd
# maven-resolver
pushd maven-resolver-maven-resolver-1.9.22
${mvn_build} -Dmaven.compiler.source=8 -Dmaven.compiler.target=8 -Dspotless.check.skip=true
popd
# maven-shared-utils
pushd maven-shared-utils-maven-shared-utils-3.4.2
${mvn_build} -Dmaven.compiler.source=8 -Dmaven.compiler.target=8
popd
# guice
pushd guice-5.1.0
${mvn_build} -Dmaven.compiler.source=1.8 -Dmaven.compiler.target=1.8
popd
# guava
pushd guava-33.2.1
${mvn_build} -Dmaven.compiler.source=1.8 -Dmaven.compiler.target=1.8
popd
# javax-annotation
pushd javax.annotation-1.3.2
${mvn_build} -Dmaven.compiler.source=1.8 -Dmaven.compiler.target=1.8
popd
# plexus-cipher
pushd plexus-cipher-plexus-cipher-2.0
${mvn_build} -Dmaven.compiler.source=8 -Dmaven.compiler.target=8
popd
# plexus-utils
pushd plexus-utils-plexus-utils-3.5.1
${mvn_build} -Dmaven.compiler.source=1.8 -Dmaven.compiler.target=1.8
popd
# sisu
pushd sisu-project-milestones-0.9.0.M3
${mvn_build} -Dmaven.compiler.source=8 -Dmaven.compiler.target=8
popd
# plexus-classworlds
pushd plexus-classworlds-plexus-classworlds-2.8.0
${mvn_build} -Dmaven.compiler.source=8 -Dmaven.compiler.target=8
popd
# plexus-sec-dispatcher
pushd plexus-sec-dispatcher-plexus-sec-dispatcher-2.0
${mvn_build} -Dmaven.compiler.source=8 -Dmaven.compiler.target=8
popd
# plexus-interpolation
pushd plexus-interpolation-plexus-interpolation-1.27
${mvn_build} -Dmaven.compiler.source=8 -Dmaven.compiler.target=8
popd
# slf4j
pushd slf4j-v_1.7.36
${mvn_build} -Dmaven.compiler.source=1.8 -Dmaven.compiler.target=1.8 -Drequired.jdk.version=8
popd
# plexus-containers
pushd plexus-containers-plexus-containers-2.1.0
${mvn_build} -Dmaven.compiler.source=8 -Dmaven.compiler.target=8
popd
# maven-wagon
pushd maven-wagon-wagon-3.5.3
${mvn_build} -Dmaven.compiler.source=8 -Dmaven.compiler.target=8
popd
# plexus-xml
pushd plexus-xml-plexus-xml-3.0.1
${mvn_build} -Dmaven.compiler.source=8 -Dmaven.compiler.target=8
popd
# commons-cli
pushd commons-cli-rel-commons-cli-1.8.0
${mvn_build} -Dmaven.compiler.source=1.8 -Dmaven.compiler.target=1.8
popd
# httpcomponents-client
pushd httpcomponents-client-rel-v4.5.14
${mvn_build} -Dmaven.compiler.source=8 -Dmaven.compiler.target=8
popd
# httpcomponents-core
pushd httpcomponents-core-rel-v4.4.16
${mvn_build} -Dmaven.compiler.source=1.8 -Dmaven.compiler.target=1.8
popd
# common-codec
pushd commons-codec-rel-commons-codec-1.17.1
${mvn_build} -Dmaven.compiler.source=8 -Dmaven.compiler.target=8
popd
# jansi
pushd jansi-jansi-2.4.1
${mvn_build} -Dmaven.compiler.source=8 -Dmaven.compiler.target=8
rm -f target/modules/jansi*.jar
popd
# maven
pushd maven-maven-3.9.9
${mvn_build} -DdistributionTargetDir=$(dirname "$(readlink -f .)")/maven-release-3.9.9 -Dmaven.compiler.source=8 -Dmaven.compiler.target=8
popd

pushd maven-release-3.9.9
find . -name "*.jar" -type f > $(dirname "$(readlink -f .)")/maven-jarlist.txt
sed -i 's|\./||g' $(dirname "$(readlink -f .)")/maven-jarlist.txt
find . -name "*.jar" -type f -delete
popd



%install
mkdir -p %{buildroot}/usr/lib/maven/
cp -rf maven-release-3.9.9/* %{buildroot}/usr/lib/maven/

for f in $(cat maven-jarlist.txt | grep boot | sed 's/.*\///g'); do
  jarfile=$(find . -name $f -type f | grep target)
  install -p -m 644 $jarfile %{buildroot}/usr/lib/maven/boot
done

for f in $(cat maven-jarlist.txt | grep lib | sed 's/.*\///g'); do
  jarfile=$(find . -name $f -type f | grep target)
  install -p -m 644 $jarfile %{buildroot}/usr/lib/maven/lib
done



mkdir -p %{buildroot}/usr/bin
pushd %{buildroot}/usr/bin
ln -s ../lib/maven/bin/mvn mvn
ln -s ../lib/maven/bin/mvnDebug mvnDebug
ln -s ../lib/maven/bin/mvnyjp mvnyjp
popd



%check
# compatbility check script has been migrated to compatibility-check.sh



%files
/usr/lib/maven/
/usr/bin/*



%changelog
* Thu Dec 19 2024 OpenCloudOS JAVA SIG <javasig@opencloudos.org> - 3.9.9-2
- [Type] other
- [DESC] delete obselete for apache-commons-lang3, it will take an error that
-        when installing apache-commons-lang3, dnf will detect maven.

* Thu Dec 19 2024 OpenCloudOS JAVA SIG <javasig@opencloudos.org> - 3.9.9-1
- [Type] bugfix
- [DESC] using upstream source code to build Maven and its runtime dependencies in one spec
- Rewrite the mvn macro (more precisely, did not use the original macro, rewrote the script for editing pom)
- Added bootstrap method
- Added jar compatibility check for JDK 8
- Fixed several CVEs

* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.8.6-10
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.8.6-9
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.8.6-8
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Jul 03 2023 Xin Cheng <denisecheng@tencent.com> - 3.8.6-7
- Replace "OpenCloudOS" with %_vender

* Mon May 22 2023 Zhao Zhen <jeremiazhao@tencent.com> - 3.8.6-6
- recovered jdk free selecting

* Fri May 05 2023 Zhao Zhen <jeremiazhao@tencent.com> - 3.8.6-5
- fixed mvn --version display error

* Fri May 05 2023 Zhao Zhen <jeremiazhao@tencent.com> - 3.8.6-4
- forced to use jdk17 as runtime

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.8.6-3
- Rebuilt for OpenCloudOS Stream 23.05

* Wed Apr 19 2023 Zhao Zhen <jeremiazhao@tencent.com> - 3.8.6-2
- switched to non-bootstrap building

* Wed Apr 12 2023 Zhao Zhen <jeremiazhao@tencent.com> - 3.8.6-1
- updated to upstream 3.8.6

* Thu Nov 24 2022 Zhao Zhen <jeremiazhao@tencent.com> - 3.6.3-1
- initial building
